function [winit] = initialWeights(data,lambda,featureEng)

[nr nc ncases] = size(data.nodeLabels);
p = size(data.nodeFeatures,1);
options = optimset('Display','iter','Diagnostics','off','GradObj','on','Hessian','on');
Xtrain = data.nodeFeatures; % d,i,s
Xtrain = reshape(Xtrain, p, nr*nc*ncases)'; % s,d
NL  = reshape(data.nodeLabels, nr*nc*ncases, 1); % i,s (-1,+1)
NL = NL(:); NL(find(NL<0))=0; % -1,1 -> (0, 1)
ytrain = NL;

w = fminunc(@logistDeriv, zeros(p,1), options, Xtrain, ytrain, lambda);

nNodeFeatures = size(data.nodeFeatures,1);
nEdgeFeatures = size(data.edgeFeatures,1);
winit = initWeights(featureEng,nNodeFeatures,nEdgeFeatures);
winit = .5*ones(length(winit),1);
winit(1:nNodeFeatures) = w/max(abs(w));